// ----------------------------------------------------------------------------
// @copyright(disclaimer) 
// Licensed Materials - Property of IBM
// IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
// (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
// 
// US Government Users Restricted Rights                                  
// Use, duplication or disclosure restricted by GSA ADP Schedule          
// Contract with IBM Corp.     
// 
// DISCLAIMER OF WARRANTIES :                                             
//                                                                        
// Permission is granted to copy and modify this  Sample code, and to
// distribute modified versions provided that both the copyright        notice,-
// and this permission notice and warranty disclaimer  appear in all copies and
// modified  versions. 
// 
// THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. IBM  AND ITS SUPPLIERS AND LICENSORS
// DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE,
// INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL
// IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT
// OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE
// SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN
// NO EVENT SHALL IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST
// REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
// CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
// REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR
// SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                   
// @endCopyright       
// ----------------------------------------------------------------------------

//******************************************************************************
//*
//* Source File Name = TExecuteDD.CPP
//*
//* TExecuteDD - Test datastore.execute
//*               for Domino.Doc connector
//*      
//*****************************************************************************


#include "stdafx.h"
#include "TExecuteDD.h"

//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif


#include "DKDatastoreDD.hpp"
#include "dkQueryableCollection.hpp"
#include "dkResultSetCursor.hpp"
#include "DKResultSetCursorScrollableDD.hpp"
#include "DKAny.hpp"
#include "DKResults.hpp"
#include "DKEntityDefDD.hpp"
#include "DKAttrDefDD.hpp"
#include "DKException.hpp"


/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;


void printDDO(DKDDO* ddo)
{
	if(ddo != NULL)
	{
		DKPid p = ddo->getPid();
		cout << "************PID************" << endl;
		cout << "PID ID: " << p.getId() << endl;
		cout << "PID DS: " << p.getDatastoreType() << endl;
		cout << "PID DS: " << p.getDatastoreName() << endl;
		cout << "PID ObjType: " << p.getObjectType() << endl;
		cout << "ID String Count: " << p.getIdStringCount() << endl;
		cout << "************DDO************" << endl;
		cout << "Object Type: " << ddo->getObjectType() << endl;
		cout << "Data Count: " << ddo->dataCount() << endl;
		for(int i = 1; i <= ddo->dataCount(); i++)
		{
			DKAny any = ddo->getData(i);
			DKString dataName = ddo->getDataName(i);
			cout << dataName << ":\t\t" << any << endl;
		}
	}
}


void printResults(DKResultSetCursorScrollableDD* pResults)
{
	cout << "printResults number in collection = " << pResults->cardinality() << endl;
	if(pResults != NULL)
	{
		 DKDDO* item = NULL;
         for (item = pResults->fetchObject(); pResults->isValid() && !pResults->isEnd(); item = pResults->fetchNext())
		 {
			if(item != 0)
			  printDDO(item);
			if(item != NULL)
				delete item;
		 }
	}
}




int main(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}

	for( int nbrArgs = 1; nbrArgs < argc; nbrArgs++ )
	{
		cout << "TExecuteDD parm " << nbrArgs << "= "<< argv[nbrArgs] << endl;
	}
	if( nbrArgs < 4 )
	{
	    cout << "TExecuteDD usage = <serverName> <userId> <pw>" << endl;
		return -1;
	}

	DKDatastoreDD* dd;
	try
	{
		DKString server = argv[1];
		DKString uid = argv[2];
		DKString pw = argv[3];
		dd = new DKDatastoreDD();
		dd->connect(server, uid, pw,"");
		if( dd->isConnected() )
		{

			//DKString qString0("((NOT([\"DocFormat\"]CONTAINS\"NOTES\"))  AND  ([\"Description\"]CONTAINS\"Request*\"))");
            //DKString qString0("([\"DocType\"]CONTAINS\"DWF*\")");
            //DKString queryParms0("ENTITY=Testing;QUERY=");
			//DKString qString0("([\"Title\"]CONTAINS\"Home*\")");
			//DKString queryParms0("ENTITY=WebPublishing;QUERY=");
			/*DKString queryString0 = queryParms0 + qString0;
			cout << "Query: " << queryString0 << endl;
			
			dkResultSetCursor* pRCS = dd->execute(queryString0, DK_PARAMETRIC_QL_TYPE, NULL);
			DKResultSetCursorScrollableDD* rcsDD = (DKResultSetCursorScrollableDD*)pRCS;
			DKString strPid;
			DKDDO *p   = 0;
			DKPid *pid = 0;
            int count  = 0;

 		    while(pRCS->isValid())
			{
				p = pRCS->fetchNext();
				count++;
                if(pRCS->isBegin())
                   cout << count << " ---------------- is Begin !!" << endl;
				if(pRCS->isEnd())
                   cout << count << " ---------------- is end !!" << endl;
				if(p==0)
				   cout << count << " ---------------- NULL @@ " << endl;
				else {
                   pid    = (DKPid*)p->getPidObject();
				   strPid = pid->pidString();
				   cout << count << " ----------------- PID String is " << strPid << endl;
				   delete p;
                }
			}
		//	printResults(rcsDD);
			delete pRCS;			

		*/	
		//	DKString qString1("([\"Title\"]CONTAINS\"Home*\")");
		//	DKString queryParms1("ENTITY=WebPublishing;QUERY=");
			DKString qString1("([\"\"DocType\"\"] CONTAINS \"\"DWF*\"\")");
            DKString queryParms1("ENTITY=WebPublishing;QUERY=");

			//   DKString qString1("([\"DocType\"]CONTAINS\"g*\")");
            //DKString queryParms1("ENTITY=Testing;QUERY=");
			DKString queryString1 = queryParms1 + qString1;
			cout << "Query: " << queryString1 << endl;
			
			dkResultSetCursor* pRCS = dd->execute(queryString1, DK_PARAMETRIC_QL_TYPE, NULL);
			DKResultSetCursorScrollableDD* rcsDD = (DKResultSetCursorScrollableDD*)pRCS;
			printResults(rcsDD);
			delete pRCS;			
			
			dd->disconnect();
			delete dd;
		}
	}
	catch( DKException dke )
	{
		for( long i = 0; i < dke.textCount(); i++ )
		{
			const char* text = dke.text(i);
			if( text != 0 )
				cout << text << endl;
		}
	}
	catch( ... )
	{
		cout << "TExecuteDD FAILURE! Caught unexpected exception." << endl;
	}

	return nRetCode;
}


