/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/
 /************************************************************************************************
 *          FILENAME: TCreateItemTypeICM.java
 *                    ---------------------------------------------------------------------------
 *       DESCRIPTION: Connect to ICM Datastore, create an item type , disconnect from ICM Datastore.
 *                    ---------------------------------------------------------------------------
 ************************************************************************************************/

 
 
import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.internal.*;
import com.ibm.mm.sdk.internal.ql.PQueryEngineICM;
import java.util.*;

public class TCreateItemTypeICM implements DKConstantICM
{

    String itemPidString="";
    String itemTypeName ="Cats";
    String childCompName ="Kittens";
    String attr1Name ="Color";
    String attr2Name ="Weight";
    DKDatastoreICM dsICM = null;
    DKPid pid = null;
    String strItemId = "";
    String strCompId = "";
    String strVersionId = "";

    public TCreateItemTypeICM(){
       setup();
    }
   

    public TCreateItemTypeICM(String itemTypeName, String childCompName, String attr1Name, String attr2Name){
        this.itemTypeName = itemTypeName;
        this.childCompName = childCompName;
        this.attr1Name = attr1Name;
        this.attr2Name = attr2Name;
        setup();
    }
      public void setup(){
        try {
            dsICM = new DKDatastoreICM();
            dsICM.connect("icmnlsdb", "icmadmin" ,"password" ,"");
            System.out.println("datastore connected.");
            dsICM.setOption(DK_CM_OPT_CACHE, new Integer(DK_CM_TRUE));
            DKDatastoreDefICM dsDefICM  = (DKDatastoreDefICM) dsICM.datastoreDef();
            DKDocRoutingServiceICM docService = new DKDocRoutingServiceICM(dsICM);
            DKDocRoutingServiceMgmtICM docMgmt = new DKDocRoutingServiceMgmtICM(dsICM);

//==============================================================================
// Create an item type
//==============================================================================

        System.out.println("\n======================== Create item type ==================================");
        DKItemTypeDefICM prj = new DKItemTypeDefICM(dsICM);
        prj.setName(this.itemTypeName);
        System.out.println("The item type name: " + itemTypeName);
        prj.setDescription("The desciption for the item type " + itemTypeName);
        prj.setClassification((short)0);
        prj.setItemLevelACLFlag((short)1);
        prj.setItemTypeACLCode(1);
        prj.setDefaultRMCode((short)0);
        prj.setDefaultCollCode((short)0);
        prj.setDefaultPrefchCollCode((short)0);
        prj.setDefaultRetentionUnit((short)3);
        prj.setDefaultItemRetention(10);
        prj.setXDOClassID(0);
        prj.setAutoLinkEnable(true);
        prj.setAutoLinkSMS((short)5);
        prj.setDeleteRule((short)1);  // this is needed for delete item (delete cascade)

        //===============================
        // stand alone attrib
        //===============================
        //(1)
        DKAttrDefICM attr1 = (DKAttrDefICM)prj.createAttr();
        //attribute name column name
        attr1.setName(attr1Name);
        System.out.println("The first attribute name: " + attr1Name);
        attr1.setDescription("The desciption for attribute " + attr1Name);
        attr1.setType(DK_CM_CHAR);
        attr1.setSize(32);
        attr1.setUnique(true);
        attr1.setNullable(false);
        try{
           attr1.add();
           prj.addAttr(attr1);
        }catch (DKAlreadyExistException e){
           System.out.println("The attribute " + attr1 + " already exists");
        }

    //==============================================================================
    // child component
    //==============================================================================
        DKComponentTypeDefICM comp1=new DKComponentTypeDefICM((dkDatastore)dsICM);
        comp1.setName(childCompName);

        System.out.println("The child component name: " + childCompName);
        comp1.setDeleteRule((short)1);

        //===============================
        // stand alone attrib
        //===============================
        DKAttrDefICM attr2=(DKAttrDefICM) comp1.createAttr();
        //attribute name column name
        attr2.setName(attr2Name);
        System.out.println("The second attribute name: " + attr2Name);
        attr2.setDescription(" The description for second attribute "  + attr2Name);
        attr2.setType(DK_CM_INTEGER);
        attr2.setUnique(false);
        attr2.setNullable(false);
        try{
        attr2.add();
        comp1.addAttr(attr2);
        }catch (DKAlreadyExistException e){
           System.out.println("The attribute " + attr2 + " already exists");
        }
        prj.addSubEntity(comp1); 
        try{
        dsDefICM.add(prj);
        }catch (DKAlreadyExistException e){
           System.out.println("The item type already exists");
        }

       
     DKDDO ddo = dsICM.createDDO(itemTypeName, 0); 
     ddo.setData((short)ddo.dataId(attr1Name), "Tabby");

     DKChildCollection child = new DKChildCollection();
     DKDDO ddo1 = dsICM.createChildDDO(itemTypeName, childCompName);
     ddo1.setData((short)ddo1.dataId(attr2Name), new Integer(2));
     child.addElement(ddo1);

     ddo.setData((short) ddo.dataId(DKConstant.DK_CM_NAMESPACE_CHILD, childCompName), child);
     ddo.add();
            itemPidString = retrieveItemPidString(dsICM, itemTypeName, attr1Name, "Tabby");
            System.out.println("The pid of the item type=\n" +itemPidString );

     } catch (Exception e) {e.printStackTrace();}
    }

    
 public String getPid (){
   return itemPidString;
}

   public static String retrieveItemPidString(DKDatastoreICM dsICM, String itemType, String attrName, String value)
    throws DKException, Exception
   {  
       String queryStr ="/" + itemType + "[@" + attrName + "= \"" + value + "\"]";
       DKPidICM pid = retrievePid(dsICM, queryStr);
       return pid.pidString();
   }

   public static DKPidICM retrievePid(DKDatastoreICM dsICM, String queryStr)
    throws DKException, Exception
   {
      DKResults results = (DKResults) dsICM.evaluate(queryStr, DKConstant.DK_CM_XQPE_QL_TYPE, null);
      Vector v = new Vector();
      DKPidICM pid = null;
      if (results != null) {
         dkIterator iter = results.createIterator();
         while (iter.more()) {
            DKDDO item = (DKDDO) iter.next();
            if (item != null) {
                item.retrieve(DKConstantICM.DK_CM_CONTENT_ITEMTREE);
                return (DKPidICM)item.getPidObject();
            }
         }
      }
      return null;
   }
 
}
